unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, StrUtils, Menus, ExtCtrls, ScktComp, math,
  XPMan;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    ListView1: TListView;
    Panel1: TPanel;
    Edit1: TEdit;
    ClientSocket1: TClientSocket;
    XPManifest1: TXPManifest;
    N01: TMenuItem;
    procedure N2Click(Sender: TObject);
    procedure ListView1CustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure Edit1Change(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure ClientSocket1Connecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure ListView1ColumnClick(Sender: TObject; Column: TListColumn);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    procedure tryfind;
    procedure Loaded_;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  SortIndex : Integer = -1;
  bstop:boolean=False;

implementation

{$R *.dfm}

const
  vvv = '<tr>'+#13#10#13#10+
'<td bgcolor="#5B86F7" width=135><strong><font face="Arial" size="-1" color="#FFFFFF">Clients</font></strong></td>'+#13#10#13#10+
'<td bgcolor="#5B86F7" width=55><strong><font face="Arial" size="-1" color="#FFFFFF">Karma</font></strong></td>'+#13#10#13#10+
'<td bgcolor="#5B86F7" width=55><strong><font face="Arial" size="-1" color="#FFFFFF">Kills</font></strong></td>'+#13#10#13#10+
'<td bgcolor="#5B86F7" width=55><strong><font face="Arial" size="-1" color="#FFFFFF">Fame</font></strong></td>'+#13#10#13#10+
'<td bgcolor="#5B86F7" width=80><strong><font face="Arial" size="-1" color="#FFFFFF">Guild</font></strong></td>'+#13#10#13#10+
'</tr>'+#13#10#13#10+
'<tr>'+#13#10#13#10+
'<td align="right"><font face="Arial">'+#13#10#13#10;


type
  TStat = record
    Clients : AnsiString; lClients : AnsiString;
    Karma   : Integer; sKarma : AnsiString;
    Kills   : Integer; sKills : AnsiString;
    Fame    : Integer; sFame  : AnsiString;
    Guild   : AnsiString;
  end;

var astat : array of TStat;
    sBuffer : AnsiString;

function Add(Clients:AnsiString;Karma:Integer;Kills:Integer;Fame:Integer;Guild:AnsiString):integer;
var j:integer;
begin
  j := length(astat);
  setlength(astat, j+1);
  astat[j].Clients := Clients; astat[j].lClients := AnsiLowerCase(astat[j].Clients);
  astat[j].Karma   := Karma; astat[j].sKarma := intTostr(Karma);
  astat[j].Kills   := Kills; astat[j].sKills := intTostr(Kills);
  astat[j].Fame    := Fame;  astat[j].sFame  := intTostr(Fame);
  astat[j].Guild   := Guild;
  result           := j;
end;

function copy2(const s:AnsiString; start_pos, end_pos:Integer):AnsiString;
begin
  result := copy(s, start_pos, end_pos-start_pos+1);
end;

function xxxx2(const s:AnsiString):AnsiString;
var p,j:Integer;
begin
  result := s;
  while true do
  begin
    p := pos('<', result);
    j := pos('>', result);
    if (p<>0) and (j<>0) then
    begin
      delete(result,p,j-p+1);
    end
                         else
    begin
      break
    end
  end;
end;

function xxxx(var s:AnsiString):AnsiString;
var p,j:Integer;
begin
  p  := pos('<td>', s);
  j  := pos('</td>', s);
  result := xxxx2(copy2(s, p+4, j-1));
  delete(s, 1, j+4);
end;

procedure TForm1.N2Click(Sender: TObject);
begin
  if Application.messagebox('?', ' ', mb_iconquestion or mb_yesno)=idyes then  Close
end;

procedure TForm1.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  if item<>nil then
    if odd(Item.Index) then sender.canvas.brush.Color := $00F9F9F9
                       else sender.canvas.brush.Color := clwhite;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  tryfind;
end;
function CustomDateSortProc(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
var s1, s2 : AnsiString;
    i1, i2 : Integer;
begin
  result:=0;


  case ParamSort of
    0,4 : begin
            if ParamSort=0 then begin
                                  s1 := AnsiLowerCase(item1.Caption);
                                  s2 := AnsiLowerCase(item2.Caption);
                                end
                           else begin
                                  s1 := AnsiLowerCase(item1.SubItems[3]);
                                  s2 := AnsiLowerCase(item2.SubItems[3]);
                                end;
            i1 := Length(s1);
            i2 := Length(s2);
            if (i1=0) or (i2=0) then
            begin
              if (i1=0) and (i2>0) then Result := 1
                                   else if (i1>0) and (i2=0) then Result := -1;
            end
                                else
            begin
              if s1>s2 then Result := 1
                       else if s1<s2 then Result := -1;
            end
          end;
    1,2,3 : begin
              s1 := item1.SubItems[ParamSort-1];
              s2 := item2.SubItems[ParamSort-1];
              if trystrtoint(s1, i1) and trystrtoint(s2, i2) then
              begin
                if i1>i2 then Result := -1
                         else if i1<i2 then Result := 1;
              end;
            end;
  end;
end;


procedure TForm1.tryfind;
var s:AnsiString;
j:integer;
li:TListItem;
begin
//----------------------------
  s     := AnsiLowerCase(edit1.Text);
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  for j:=0 to high(astat) do
  begin
    if (s<>'') and (pos(s, astat[j].lClients)=0) then continue;
    li := ListView1.Items.Add;
    li.Caption := astat[j].Clients;
    li.SubItems.Add(astat[j].sKarma);
    li.SubItems.Add(astat[j].sKills);
    li.SubItems.Add(astat[j].sFame);
    li.SubItems.Add(astat[j].Guild);
  end;
  ListView1.CustomSort(@CustomDateSortProc, SortIndex);
  ListView1.Items.EndUpdate;
  N01.Caption := inttostr(ListView1.Items.Count)
end;

procedure TForm1.Loaded_;
var
  buff,s,s1,s2,s3,s4,s5,Clients,Guild : AnsiString;
  p,j,l,k,Karma,Kills,Fame            : Integer;
  bol                                 : boolean;
  li                                  : TListItem;
  pc, start                           : PChar;
begin
  setlength(astat, 0);
  buff    := sBuffer;
  sBuffer := '';
  pc      := Pointer(buff);
  l       := 0;
  if pc <> nil then
    while pc^ <> #0 do
      begin
      Start := pc;
      while not (pc^ in [#0, #10, #13]) do Inc(pc);
      SetString(S, Start, pc - Start);
      k := length(s);
      if k>l then
      begin
        s1 := s;
        l  := k;
      end;
      if pc^ = #13 then Inc(pc);
      if pc^ = #10 then Inc(pc);
    end;
  buff := s1;  
  bol  := True;
  while bol do
  begin
    p := posex('<tr ', buff, 2);
    if p=0 then
    begin
      s   := copy(buff, 1, maxint);
      bol := False;
    end
           else
    begin
      s := copy(buff, 1, p);
      delete(buff, 1, p);
    end;
//------------------------------------------------------------------------------
    s1 := xxxx(s);
    s2 := xxxx(s);
    s3 := xxxx(s);
    s4 := xxxx(s);
    s5 := xxxx(s);
    if s5='&nbsp' then s5 := '';

    Clients := s1;
    if trystrtoint(s2, Karma) then
      if trystrtoint(s3, Kills) then
        if trystrtoint(s4, Fame) then
        begin
          Guild := s5;
          Add(Clients, Karma, Kills, Fame, Guild);
        end;
  end;

  s := AnsiLowerCase(Edit1.Text);
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  for j:=0 to high(astat) do
  begin
    if (s<>'') and (pos(s, astat[j].lClients)=0) then continue;
    li := ListView1.Items.Add;
    li.Caption := astat[j].Clients;
    li.SubItems.Add(astat[j].sKarma);
    li.SubItems.Add(astat[j].sKills);
    li.SubItems.Add(astat[j].sFame);
    li.SubItems.Add(astat[j].Guild);
  end;
  ListView1.Items.EndUpdate;
  StatusBar1.SimpleText := '';
  N01.Caption := inttostr(ListView1.Items.Count)
end;

procedure TForm1.N1Click(Sender: TObject);
begin
  if ClientSocket1.Active then
  begin
    bstop := True;
    ClientSocket1.Close;
  end
                          else
  begin
    SortIndex          := -1; 
    bstop              := False;
    ClientSocket1.Host := 'www.drw.ru';
    ClientSocket1.Port := 80;
    ClientSocket1.Open;
  end
end;

procedure TForm1.ClientSocket1Connecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  StatusBar1.SimpleText := '  ww.drw.ru ...';
end;

procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  if bstop then StatusBar1.SimpleText := ''
           else begin
                  StatusBar1.SimpleText := '';
                  if length(sBuffer)>0 then
                    loaded_;
                end
end;

procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
const
  sendbuff = 'GET /status/ HTTP/1.0'+#13#10+
             'Host: www.drw.ru'+#13#10+
             'Accept: text/html, */*'+#13#10+
             'User-Agent: Mozilla/3.0 (compatible; Delphi Client Socket)'+#13#10#13#10;
begin
  StatusBar1.SimpleText := '  www.drw.ru ('+Socket.RemoteAddress+') ';
  sBuffer               := '';
  Socket.SendText(sendbuff);
end;

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  sBuffer := sBuffer + Socket.ReceiveText;
  StatusBar1.SimpleText := '   www.drw.ru ('+Socket.RemoteAddress+') -> '+inttostr(length(sBuffer))+' ';
end;

procedure TForm1.ListView1ColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  SortIndex := Column.Index;
  ListView1.CustomSort(@CustomDateSortProc, SortIndex)
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=vk_f5 then
    N1Click(nil);
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if not edit1.Focused then
  begin
    edit1.SetFocus;
    if key<#32 then key:=#0;
    edit1.Text      := key;
    edit1.SelLength := 1;
    edit1.SelStart  := 1;
  end
end;

end.
